<?php
/*
* XRay CMS - Functions File
* 
* This file is used by the CMS
* to store the functions used
* by it
* 
* REQUIRES: data/data.php
* 
* EDIT: NO
*/
	
if(!(defined("FUNCTIONS_INITIALIZED")))
{
	define("FUNCTIONS_INITIALIZED", "true");
	if(!(defined("DATA_INITIALIZED")))
	{
		require "data.php";
	}
	
	/*
	* ==: DATABASE FUNCTIONS :==
	*/
	
	
	function xray_db_connect() //Connect to database
	{
		$return = mysql_connect(DB_HOST, DB_USERNAME, DB_PASSWORD);
		
		if($return != false)
		{
			if(!defined("DB_CONNECTED")) define("DB_CONNECTED", "true");
			return $return;
		}
		else
		{
			if(!defined("DB_CONNECTED")) define("DB_CONNECTED", "false");
			if(!defined("DB_ERROR")) define("DB_ERROR", mysql_error());
			return false;
		}
	}
	
	function xray_db_select() //Select Database
	{
		$return = mysql_select_db(DB_NAME);
		
		if($return != false)
		{
			if(!defined("DB_SELECTED")) define("DB_SELECTED", "true");
			return $return;
		}
		else
		{
			if(!defined("DB_SELECTED")) define("DB_SELECTED", "false");
			if(!defined("DB_ERROR")) define("DB_ERROR", mysql_error());
			return false;
		}
	}
	
	function xray_db_check($fatal = true)
	{
		$connect_check = 0;
		$select_check = 0;
		$error = null;
		
		if(defined("DB_CONNECTED"))
		{
			if(DB_CONNECTED == "true") $connect_check = 1;
			else $connect_check = 2;
		}
		if(defined("DB_SELECTED"))
		{
			if(DB_SELECTED == "true") $select_check = 1;
			else $connect_check = 2;
		}
		if(defined("DB_ERROR"))
		{
			$error = DB_ERROR;
		}
		
		
		
		
		if($connect_check == 2)
		{
			errorbox("The database connection returned an error: ".__br().DB_ERROR);
			if($fatal) exit;
		}
		else if($connect_check == 0)
		{
			errorbox("The database has not been connected!");
			if($fatal) exit;
		}
		
		if($select_check == 2)
		{
			errorbox("The database selection returned an error: ".__br().DB_ERROR);
			if($fatal) exit;
		}
		else if($select_check == 0)
		{
			errorbox("The database has not been selected!");
			if($fatal) exit;
		}
	}
	
	function xray_db_query($query) //Execute a query to the database
	{
		$return = mysql_query($query);
		if(!$return) die(mysql_error());
		return $return;
	}
	
	function xray_db_prefix() //Get the database prefix
	{
		return DB_PREFIX;
	}
	
	function xray_db_get_field($field, $query) //Returns the value of a queried field
	{
		while($r = mysql_fetch_array($query))
		{
			return $r[$field];
		}
	}
	
	function xray_db_simple_select($fields, $table, $where = null) //Run a SELECT SQL
	{
		$sql = "SELECT $fields FROM `$table`";
		if($where != null) $sql = $sql." WHERE $where";
		return mysql_query($sql);
	}
	
	function xray_db_table($name) //Returns "`<PREFIX>$name`"
	{
		return "`".xray_db_prefix().$name."`";
	}
	
	function xray_db_get_pref($pref) //Get a prefrence from [prefix]prefs
	{
		$prefix = xray_db_prefix();
		$q = xray_db_query("SELECT * FROM `xray_pref` WHERE `key` LIKE 'title'");
		$rt = mysql_fetch_array($q);
		return $rt['value'];
	}
		
	
	/*
	* ==: GENERAL/LAYOUT FUNCTIONS :==
	*/
	function clearfloats() //Fix a conflict with the CSS for Boxes and Floating blocks
	{
		print "<div class=\"clearfloats\"><!-- CSS Style-fix: Clearfloats --></div>\n";
	}
	
	function __xray_box_begin($header, $class = null) //Begin a "box"
	{
		return "<div class=\"box\">\n<div class=\"boxtop $class\">\n<div></div></div>\n
		<div class=\"boxcontent\">\n<b class=\"boxheader\">$header</b><br />\n";
	}
	
	function __xray_box_end() //End a "box", always remember to close open boxes
	{
		return "</div>\n<div class=\"boxbot\"><div></div></div>\n</div>";
	}
	
	function xray_box_begin($header, $class = null)
	{
		print __xray_box_begin($header, $class);
	}
	
	function xray_box_end()
	{
		print __xray_box_end();
	}
	
	function errorbox($msg, $hide=true)
	{
		print "<div class=\"error\">"; n();
		print "<center>$msg</center>"; n();
		if($hide)
		{
			print "<a href=\"index.php\" class=\"hidelink\" onclick=\"$(this.parentNode).switchOff(); return false;\">";
			print "<small>[close]</small>";
			print "</a>";
			n();
		}
		print "<div style=\"clear: both;\"></div>";
		print "</div>"; n();
	}
	
	function warningbox($msg, $hide=true)
	{
		print "<div class=\"warning\">"; n();
		print "<center>$msg</center>"; n();
		if($hide)
		{
			print "<a href=\"index.php\" class=\"hidelink\" onclick=\"$(this.parentNode).switchOff(); return false;\">";
			print "<small>[close]</small>";
			print "</a>";
			n();
		}
		print "<div style=\"clear: both;\"></div>";
		print "</div>"; n();
	}
	
	
	function messagebox($msg, $hide=true)
	{
		print "<div class=\"message\"";
		print ">"; n();
		print "<center>$msg</center>"; n();
		if($hide)
		{
			print "<a href=\"index.php\" class=\"hidelink\" onclick=\"$(this.parentNode).switchOff(); return false;\">";
			print "<small>[close]</small>";
			print "</a>";
			n();
		}
		print "<div style=\"clear: both;\"></div>";
		print "</div>"; n();
	}
	
	function __br() //Inserts "<br />" and a newline
	{
		return "<br />\n";
	}
	
	function br()
	{
		print __br();
	}
	
	function __hr() //Inserts a line("<hr />") and a newline
	{
		return "<hr />\n";
	}
	
	function hr()
	{
		print __hr();
	}
	
	function __nbsp()
	{
		return "&nbsp;";
	}
	
	function nbsp()
	{
		print __nbsp();
	}
	
	function __n()
	{
		return "\n";
	}

	function n()
	{
		print __n();
	}
	
	function __xray_button($text, $href, $img = null, $target = null)
	{
		$return = "<a href=\"$href\"";
		if($target != null) $return = $return." target=\"$target\"";
		$return = $return."><div class=\"button\">\n";
		if($img != null) $return = $return."<img src=\"$img\" alt=\"[$text]\" />\n";
		$return = $return."<br />\n$text\n</div></a>";
		
		return $return;
	}
	
	function xray_button($text, $href, $img = null, $target = null)
	{
		print __xray_button($text, $href, $img, $target);
	}
	
	function __xray_tab($text, $href, $selected = false, $target = null, $id = null)
	{
		$return = "";
		
		if($id != null) $return = $return."<div id=\"$id\" name=\"$id\">";
		
		$return = $return."<a href=\"$href\"";
		if($target != null) $return = $return." target=\"$target\"";
		$return = $return.">";
		
		$return = $return."<div class=\"tab";
		if($selected) $return = $return.", tab_selected";
		$return = $return."\">$text</div></a>";
		
		if($id != null) $return = $return."</div>\n";
		
		return $return;
	}
	
	function xray_tab($text, $href, $selected = false, $target = null, $id = null)
	{
		print __xray_tab($text, $href, $selected, $target, $id);
	}
	
	function __xray_loading($path = ".")
	{
		$return = "<img src=\"".$path."/graphics/gif/loading.gif\" alt=\"Loading...\" />";
		
		return $return;
	}
	
	function xray_loading($path = ".")
	{
		print __xray_loading($path);
	}
	
	/*
	* ==: SYSTEM FUNCTIONS :==
	*/
	
	function getURL()
	{
		$return = 'http';
		if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
		$return .= "://";
		
		if ($_SERVER["SERVER_PORT"] != "80")
		{
			$return .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].
				$_SERVER["REQUEST_URI"];
		}
		else
		{
			$return .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		}
		
		return $return;
	}
	
	function getPage()
	{
		return substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
	}
	
	function setsession($key, $value, $noprefix = false)
	{
		if($noprefix) $_SESSION[$key] = $value;
		else $_SESSION[SESSION_PREFIX.$key] = $value;
	}
	
	function unsetsession($key, $noprefix = false)
	{
		if($noprefix) unset($_SESSION[$key]);
		else unset($_SESSION[SESSION_PREFIX.$key]);
	}
	
	function getsession($key, $noprefix = false)
	{
		if($noprefix && checksession($key, true)) return $_SESSION[$key];
		else if(!$noprefix && checksession($key)) return $_SESSION[SESSION_PREFIX.$key];
		else return false;
	}
	
	function checksession($key, $noprefix = false)
	{
		if($noprefix) return isset($_SESSION[$key]);
		else return isset($_SESSION[SESSION_PREFIX.$key]);
	}
	
	/*
	* ==: SECURITY FUNCTIONS :==
	*/
	
	//Returns the current user's Group ID; Returns -1 for not logged in/banned users
	function xray_get_group()
	{
		@session_start();
		
		if(checksession("username") && checksession("password"))
		{
			$res = xray_db_query("SELECT * FROM `".xray_db_prefix()."users` WHERE ".
			"`username` LIKE '".getsession("username")."'");
			$group = xray_db_get_field("group", $res);
			return intval($group);
		}
		else
		{
			return -1;
		}
	}
	
	//Checks if the current user has access to the specified function; returns true or false
	function xray_check_access($module, $access)
	{
		if(!isset($group)) require "groups.php";
		
		$grp = xray_get_group();
		if(!isset($group[$grp]))
			die("Your group has been deleted. Please contact an administrator.");
		else $prv = $group[$grp]["access"];
		if(
			strpos($prv, strtoupper($module).strtoupper($access)) !== false ||
			strpos($prv, strtoupper($module)."ALL") !== false ||
			strpos($prv, "SUPERALL") !== false
		)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function xray_access($module, $access)
	{
		if(!(xray_check_access($module, $access)))
		{
			die("You don't have permission to be here!");
		}
	}
	
	function xray_check_group_id($gid)
	{
		$grp = xray_get_group();
		if($grp == $gid) { return true; }
		else { return false; }
	}
	
	function xray_get_user()
	{
		if(!isset($group)) require "groups.php";
		@session_start();
		
		if(checksession("username") && checksession("password"))
		{
			$res = xray_db_query("SELECT * FROM `".xray_db_prefix()."users` WHERE ".
			"`username` LIKE '".getsession("username")."'");
			$id = xray_db_get_field("id", $res);
			return intval($group);
		}
		else
		{
			return -1;
		}
	}
	
	/*
	* ==: POST/PAGE FUNCTIONS :==
	*/
	function xray_post_comments($id)
	{
		$res = xray_db_query("SELECT * FROM ".xray_db_table("post_comments")." WHERE `post` =".$id);
		mysql_error();
		
		while($r = mysql_fetch_array($res))
		{
			$user = "";
			if($r['uid'] != "-1")
			{
				$u_res = xray_db_query("SELECT * FROM ".xray_db_table("users")." WHERE `id` =".$r['uid']);
				$u_r = mysql_fetch_array($u_res);
				$user = $u_r['username'];
			}
			else
			{
				$user = "<i>(anonymous)</i>";
			}
			xray_box_begin($user." <small><i>- ".$r['date']."</i></small>");
			print $r['content'];
			xray_box_end();
		}
	}
}
?>